package com.huimv.center.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.center.mapper.BizDeviceRegisterMapper;
import com.huimv.center.pojo.BizDeviceRegister;
import com.huimv.center.service.BizDeviceRegisterService;
import com.huimv.center.utils.DateUtil;
import com.huimv.center.utils.IDUtil;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-06-21
 */
@Service
public class BizDeviceRegisterServiceImpl extends ServiceImpl<BizDeviceRegisterMapper, BizDeviceRegister> implements BizDeviceRegisterService {
    @Autowired
    private BizDeviceRegisterMapper BizDeviceRegisterMapper;
    @Autowired
    private com.huimv.center.utils.ResultUtil ResultUtil;
    @Autowired
    private DateUtil dateUtil;
    @Autowired
    private IDUtil idUtil;

    @Override
    public Result add(String chip_id, String device_code, String register_date, String server_ip, String server_port, String remark) throws ParseException {
        BizDeviceRegister deviceRegister = new BizDeviceRegister();
        deviceRegister.setChipId(chip_id);
        deviceRegister.setDeviceCode(device_code);
        deviceRegister.setRegisterDate(dateUtil.dateTextToTimestamp(register_date));
        deviceRegister.setServerIp(server_ip);
        deviceRegister.setServerPort(server_port);
        deviceRegister.setRemark(remark);
        int rows = BizDeviceRegisterMapper.insert(deviceRegister);
        return ResultUtil.result(rows);
    }

    @Override
    public Result edit(Integer id, String chip_id, String device_code, String register_date, String server_ip, String server_port, String remark) throws ParseException {
        BizDeviceRegister deviceRegister = BizDeviceRegisterMapper.selectById(id);
        deviceRegister.setChipId(chip_id);
        deviceRegister.setDeviceCode(device_code);
        deviceRegister.setRegisterDate(dateUtil.dateTextToTimestamp(register_date));
        deviceRegister.setServerIp(server_ip);
        deviceRegister.setServerPort(server_port);
        deviceRegister.setRemark(remark);
        int rows = BizDeviceRegisterMapper.updateById(deviceRegister);
        return ResultUtil.result(rows);
    }

    @Override
    public Result remove(String ids){
        int rows = BizDeviceRegisterMapper.deleteBatchIds(idUtil.convert(ids));
        return ResultUtil.result(rows);
    }

    @Override
    public Result listAll(){
        // 分页显示

        return new Result(ResultCode.SUCCESS);
    }
}
