package com.huimv.center.service.impl;

import com.huimv.center.pojo.BizFarm;
import com.huimv.center.mapper.BizFarmMapper;
import com.huimv.center.service.BizFarmService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-06-21
 */
@Service
public class BizFarmServiceImpl extends ServiceImpl<BizFarmMapper, BizFarm> implements BizFarmService {
    @Autowired
    private BizFarmMapper BizFarmMapper;
    private BizFarm farm;

    @Override
    public Result save(String farmName, String farmCode, String linkman, String phone, String remark) {
        BizFarm farm = new BizFarm();
        farm.setFarmName(farmName);
        farm.setFarmCode(farmCode);
        farm.setLinkman(linkman);
        farm.setPhone(phone);
        farm.setRemark(remark);
        int result = BizFarmMapper.insert(farm);
        System.out.println(result); //影响的行数
        System.out.println(farm); //影响的行数
        return new Result(ResultCode.SUCCESS, "添加成功.");
    }

    @Override
    public Result edit(Integer id, String farmName, String farmCode, String linkman, String phone, String remark){
        BizFarm farm = BizFarmMapper.selectById(id);
        farm.setFarmName(farmName);
        farm.setFarmCode(farmCode);
        farm.setLinkman(linkman);
        farm.setPhone(phone);
        farm.setRemark(remark);
        int result = BizFarmMapper.updateById(farm);
        System.out.println(result); //影响的行数
        System.out.println(farm); //影响的行数
        return new Result(ResultCode.SUCCESS, "编辑成功.");
    }

    @Autowired
    private com.huimv.center.utils.IDUtil idUtil;

    @Override
    public Result remove(String ids){
        //
        int result = BizFarmMapper.deleteBatchIds(idUtil.convert(ids));
        System.out.println(result); //影响的行数
        System.out.println(ids); //影响的行数
        return new Result(ResultCode.SUCCESS, "删除成功.");
    }
}
